#version 120   
#extension EXT_gpu_shader4 : require    


varying vec3 eyeNormal;
varying vec3 eyePosition;

void main() {  
    vec4 vertex;    
    vec3 normal;    

    vertex = gl_Vertex;  
    normal = gl_Normal;  

    // Transform the position 
    gl_Position = gl_ModelViewProjectionMatrix * vertex;    

    // Transform the normal for per-pixel lighting
    eyeNormal = gl_NormalMatrix * normal;
    
    // Transform the position to eye-space
    eyePosition = (gl_ModelViewMatrix * gl_Vertex).xyz;  
}