#version 120                                                     
#extension EXT_gpu_shader4 : require                             
 
// samplers used as the vertex and normal source                                             
uniform samplerBuffer vertexSampler;
uniform samplerBuffer normalSampler;
                                          
varying vec3 eyeNormal;
varying vec3 eyePosition;
                                                 
void main() {                                    
    vec4 vertex;                            
    vec3 normal;                               

    //                                                                 
    // Fetch the vertex components
    //
    
    // First, scale the vertex index by three, because each component is stored separately
    int offset = int(gl_Vertex.x);
    
    // Fetch x, y, and z
    vertex = texelFetchBuffer( vertexSampler, offset);
    //vertex.x = texelFetchBuffer( vertexSampler, offset).x;       
    //vertex.y = texelFetchBuffer( vertexSampler, offset + 1).x;   
    //vertex.z = texelFetchBuffer( vertexSampler, offset + 2).x;   
    //vertex.w = 1.0;                                              
    
    //
    // Fetch the normal components
    //
                 
    // Scale by 3, since the components are stored separately                               
    offset = int(gl_Vertex.y);
    
    // Fetch x, y, and z
    normal = texelFetchBuffer( normalSampler, offset).xyz;
    //normal.x = texelFetchBuffer( normalSampler, offset).x;       
    //normal.y = texelFetchBuffer( normalSampler, offset + 1).x;   
    //normal.z = texelFetchBuffer( normalSampler, offset + 2).x;   
                                                 
    // Transform the position        
    gl_Position = gl_ModelViewProjectionMatrix * vertex;         
                              
    // Transform the normal for per-pixel lighting               
    eyeNormal = gl_NormalMatrix * normal;
    
    // Transform the vertex to eye-space for lighting
    eyePosition = (gl_ModelViewMatrix * vertex).xyz;
}